#ifndef FEEDFORWARD

#define FEEDFORWARD

#define PROTOTYPE_FEEDFORWARD void FeedForward();
#define IMPLEMENT_FEEDFORWARD(x) \
void x::FeedForward() \
{ \
	for( int ctr=0;ctr<m_NumLayers;ctr++ ) \
	{ \
		/* step thru all neurons in this layer */ \
		for( int ctr1=m_NeuronCounts[ctr];ctr1>0;ctr1-- ) \
		{ \
			/* apply formula to the inputs modified by their respective weights */ \
			LPNEURON Neuron = m_NeuralNet.GetNode( POINT2D(ctr1-1,ctr) ); \
\
			if (Neuron->m_IncomingValues.size()!=0) \
			{ \
				double output = 0; \
\
				std::map<POINT2D,double>::iterator i; \
				for( i=Neuron->m_IncomingValues.begin();i!=Neuron->m_IncomingValues.end();i++ ) \
				{ \
					POINT2D From = (*i).first; \
					output+=((*i).second * Neuron->m_Weights[From]); \
				} \
\
				switch( Neuron->m_BiasType ) \
				{ \
				case BIAS_GLOBAL: output+=(m_BiasGlobal * Neuron->m_BiasWeight); \
					break; \
				case BIAS_LAYER: output+=(m_LayerBias[ctr] * Neuron->m_BiasWeight); \
					break; \
				case BIAS_NEURON: output+=(Neuron->m_Bias * Neuron->m_BiasWeight); \
					break; \
				case BIAS_NONE: \
					break; \
				} \
\
				Neuron->m_Output = output = Formula(output); \
			} \
\
			/* send this value off to the next layer */ \
			POINT2D To = m_NeuralNet.GetFirstLink( Neuron ); \
			while( !NO_VALUE(To) ) \
			{ \
				LPNEURON Destination = m_NeuralNet.GetNode( To ); \
				Destination->m_IncomingValues[POINT2D(ctr1-1,ctr)] = Neuron->m_Output; \
				To = m_NeuralNet.GetNextLink(); \
			} \
		} \
	} \
}

#endif